<template>
  <div>
    <v-card flat class="pa-10">
      <v-row justify="center">
        <v-col :cols="12" :sm="12" :md="7" :lg="7" :xl="7">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchPerfilesUsuario"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
              <v-progress-linear
                :active="isLoadingPerfiles"
                :indeterminate="isLoadingPerfiles"
                absolute
                bottom
                color="primary"
              />
            </v-toolbar>
            <v-list
              height="300"
              max-height="300"
              style="overflow: auto;"
              two-line
              subheader
            >
              <v-subheader style="position : relative;">
                PERFILES FIJOS DEL USUARIO
                <v-btn
                  style="top:10px;"
                  color="primary"
                  fab
                  dark
                  small
                  absolute
                  top
                  right
                  @click="getPerfilesFijosUsuario"
                >
                  <v-icon color="white">mdi-sync</v-icon>
                </v-btn>
              </v-subheader>
              <v-list-item-group
                v-model="selectedPerfilesUsuario"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedPerfilesUsuario"
                  :key="indexItem"
                >
                  <template v-slot:default="{}">
                    <v-list-item-avatar>
                      <v-icon large>mdi-account-group-outline</v-icon>
                    </v-list-item-avatar>
                    <v-list-item-content>
                      <v-list-item-title>
                        <router-link
                          class="text-decoration-underline"
                          :to="toPerfil(item)"
                        >
                          {{ item.descripcion }}
                        </router-link>
                      </v-list-item-title>
                    </v-list-item-content>
                  </template>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
      </v-row>
    </v-card>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-PerfilesFijos",
  props: ["usuarioIn"],
  data() {
    return {
      isLoadingPerfiles: false,
      searchPerfilesUsuario: null,
      selectedPerfilesUsuario: null,
      perfilesUsuario: [],
      usuario: this.usuarioIn,
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchedPerfilesUsuario() {
      let tempData = this.perfilesUsuario;
      if (this.searchPerfilesUsuario != "" && this.searchPerfilesUsuario) {
        tempData = tempData.filter((item) => {
          return JSON.stringify(item)
            .toUpperCase()
            .includes(this.searchPerfilesUsuario.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.descripcion.toLowerCase();
          let fb = b.descripcion.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  methods: {
    toPerfil(perfil) {
      return {
        name: "accesos_perfiles_edicion",
        params: {
          perfil: this.serviceCommons.objectToBase64(perfil),
        },
      };
    },
    getPerfilesFijosUsuario() {
      this.isLoadingPerfiles = true;
      axios(
        "/accesos/sistema/perfiles/v1/usuarios/" +
          this.usuario.numeroEmpleado +
          "/fijos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.perfilesUsuario = data.resultado.perfiles;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.perfilesUsuario = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.isLoadingPerfiles = false;
        });
    },
  },
  created() {
    this.getPerfilesFijosUsuario();
  },
};
</script>
